/**
 * Copyright (c) 2014-present, Facebook, Inc. All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 *
 * 
 */
'use strict';








var _jasmine_async = require('./jasmine_async');var _jasmine_async2 = _interopRequireDefault(_jasmine_async);
var _path = require('path');var _path2 = _interopRequireDefault(_path);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}const JasmineReporter = require('./reporter');

const JASMINE_PATH = require.resolve('../vendor/jasmine-2.5.2.js');

function jasmine2(
globalConfig,
config,
environment,
runtime,
testPath)
{
  const reporter = new JasmineReporter(
  globalConfig,
  config,
  environment,
  testPath);

  const requireJasmine = runtime.requireInternalModule(JASMINE_PATH);
  // environment.runScript(jasmineScript);

  // const requireJasmine = environment.global.jasmineRequire;
  const jasmine = requireJasmine.core(requireJasmine);

  const env = jasmine.getEnv();
  const jasmineInterface = requireJasmine.interface(jasmine, env);
  Object.assign(environment.global, jasmineInterface);
  env.addReporter(jasmineInterface.jsApiReporter);

  _jasmine_async2.default.install(environment.global);

  environment.global.test = environment.global.it;
  environment.global.it.only = environment.global.fit;
  environment.global.it.skip = environment.global.xit;
  environment.global.xtest = environment.global.xit;
  environment.global.describe.skip = environment.global.xdescribe;
  environment.global.describe.only = environment.global.fdescribe;

  env.beforeEach(() => {
    if (config.resetModules) {
      runtime.resetModules();
    }

    if (config.clearMocks) {
      runtime.clearAllMocks();
    }

    if (config.resetMocks) {
      runtime.resetAllMocks();
    }
  });

  env.addReporter(reporter);

  runtime.requireInternalModule(_path2.default.resolve(__dirname, './jest_expect.js'))({
    expand: globalConfig.expand });


  const snapshotState = runtime.requireInternalModule(
  _path2.default.resolve(__dirname, './setup_jest_globals.js'))(
  {
    config,
    globalConfig,
    localRequire: runtime.requireModule.bind(runtime),
    testPath });


  if (config.setupTestFrameworkScriptFile) {
    runtime.requireModule(config.setupTestFrameworkScriptFile);
  }

  if (config.timers === 'fake') {
    environment.fakeTimers.useFakeTimers();
  }

  if (config.testNamePattern) {
    const testNameRegex = new RegExp(config.testNamePattern, 'i');
    env.specFilter = spec => testNameRegex.test(spec.getFullName());
  }

  runtime.requireModule(testPath);
  env.execute();
  return reporter.
  getResults().
  then(results => addSnapshotData(results, globalConfig, snapshotState));
}

const addSnapshotData = (results, globalConfig, snapshotState) => {
  results.testResults.forEach((_ref) => {let fullName = _ref.fullName,status = _ref.status;
    if (status === 'pending' || status === 'failed') {
      // if test is skipped or failed, we don't want to mark
      // its snapshots as obsolete.
      snapshotState.markSnapshotsAsCheckedForTest(fullName);
    }
  });

  const updateSnapshot = globalConfig.updateSnapshot;
  const uncheckedCount = snapshotState.getUncheckedCount();
  if (updateSnapshot) {
    snapshotState.removeUncheckedKeys();
  }
  const status = snapshotState.save(updateSnapshot);

  results.snapshot.fileDeleted = status.deleted;
  results.snapshot.added = snapshotState.added;
  results.snapshot.matched = snapshotState.matched;
  results.snapshot.unmatched = snapshotState.unmatched;
  results.snapshot.updated = snapshotState.updated;
  results.snapshot.unchecked = !status.deleted ? uncheckedCount : 0;
  return results;
};

module.exports = jasmine2;